--Default displays to on
FarmSesh_Frame:Show()
FarmSesh_FrameScroll:Show()
FarmSesh_FrameScrollText:Show()
FarmSesh_FrameScrollText:Disable()



--setup slash command to toggle window display
SLASH_FARMSESH1 = "/fs"
SlashCmdList["FARMSESH"] = function(msg)
   if (msg=="toggle") then
	   FarmSesh_Enabled = not FarmSesh_Enabled
	   if (FarmSesh_Enabled) then
			FarmSesh_Frame:Show()
			FarmSesh_FrameScroll:Show()
			FarmSesh_FrameScrollText:Show()
		else
			FarmSesh_Frame:Hide()
			FarmSesh_FrameScroll:Hide()
			FarmSesh_FrameScrollText:Hide()
		end
	elseif(msg=="timer") then
		FarmSesh_Timer_Enabled = not FarmSesh_Timer_Enabled
	    if (FarmSesh_Timer_Enabled) then
			FarmSesh_Timer:Show()
		else
			FarmSesh_Timer:Hide()
		end
	elseif (msg=="debugtable") then
		local table=FarmSesh_ItemDatabase
		Crash()
	end
	
end 

--register events
--chat messages add loot or money to chat window when items or money are looted
FarmSesh_Frame:RegisterEvent("CHAT_MSG_LOOT")
FarmSesh_Frame:RegisterEvent("CHAT_MSG_MONEY")

--player money updates gold earned this session when player wealth changes
--FarmSesh_Frame:RegisterEvent("PLAYER_MONEY") 

--player entering world and addon loaded are used for saved variables
FarmSesh_Frame:RegisterEvent("PLAYER_ENTERING_WORLD")
FarmSesh_Frame:RegisterEvent("ADDON_LOADED")

--when the player logs out save current timer status
FarmSesh_Frame:RegisterEvent("PLAYER_LOGOUT")


--Get Icon adds the icon texture next to the item link
local function GetIcon(link)
	local texture = GetItemIcon(link)
	return "\124T" .. texture .. ":" .. 12 .. "\124t" .. link
end


--Redraws the Farm Session window contents
local function UpdateFrame()
	
	local currentMoney = GetMoney()
	FarmSesh_FrameScrollText:SetText("Money: ")
		
	--Show currency
	FarmSesh_FrameScrollText:SetText(FarmSesh_FrameScrollText:GetText() ..GetCoinTextureString(FarmSesh_MoneyAcquired,10).."\n\n")
	--Show items sorted by rarity
	for rarity=8, 0, -1 do
		for i=0, FarmSesh_ItemDatabase[rarity].listLength - 1 do
			FarmSesh_FrameScrollText:SetText(FarmSesh_FrameScrollText:GetText()..GetIcon(FarmSesh_ItemDatabase[rarity][i].itemLink).." x"..FarmSesh_ItemDatabase[rarity][i].totalLooted.." ("..GetCoinTextureString(FarmSesh_ItemDatabase[rarity][i].sellPrice*FarmSesh_ItemDatabase[rarity][i].totalLooted,10)..")\n")
		end
	end
end


--Start a new farm session
local function FarmSeshClearTable()
	FarmSesh_BaseTime = GetServerTime()
	FarmSesh_MoneyAcquired = 0
	FarmSesh_ItemDatabase = {}
	for rarity = 0, 8 do
		FarmSesh_ItemDatabase[rarity] = {}
		FarmSesh_ItemDatabase[rarity].listLength = 0
	end
	FarmSesh_RunningTicker = 0
	UpdateFrame()
end


--Handle new loot received
local function ItemReceived(arg2, arg3)
    local _text = arg2;
	--parse out the item name
    local _itemName = (string.match(_text, "%[(.-)%]"))
	--parse out the item link
	local _itemLink = string.match(_text,"|%x+|Hitem:.-|h.-|h|r")	
	--get additional item info
	local _infoName, _infoLink, _infoRarity, _infoLevel, _infoMinLevel, _infoType, _infoSubType, _infoStackCount, _infoEquipLoc, _infoTexture, _infoSellPrice = GetItemInfo(_itemLink)
	--If there is no sell price information available set the sell value to 0
	if (_infoSellPrice == nil) then
		_infoSellPrice = 0
	end
	--If quest item ignore and move on with life.
	if(_infoType == "Quest") then
		return
	end
	--If someone else got the loot ignore and move on with life.
	local _realm = GetRealmName() 
	_realm = _realm:gsub("%s+", "")
	if (arg3 ~= (UnitName("Player").."-".._realm)) then
		--print("other name found: "..arg3)
		return
    end
	
	--get the number of items looted
	local _itemCount_temp = (string.match(_text, "x%d+"))
	if(_itemCount_temp==nil) then
		_itemCount = 1
	else
		_itemCount = tonumber((string.match(_itemCount_temp, "%d+")))
	end

	--Check to see if we have looted the item before and if so increment, if not add the item to the database
	local _itemLootedBefore = false
	for i=0, FarmSesh_ItemDatabase[_infoRarity].listLength-1 do
		if (FarmSesh_ItemDatabase[_infoRarity][i].itemName == _itemName) then
			FarmSesh_ItemDatabase[_infoRarity][i].totalLooted = FarmSesh_ItemDatabase[_infoRarity][i].totalLooted + _itemCount
			_itemLootedBefore = true;
			break
		end
	end
	if (_itemLootedBefore == false) then
		local _count = FarmSesh_ItemDatabase[_infoRarity].listLength
		FarmSesh_ItemDatabase[_infoRarity][_count] = {}
		FarmSesh_ItemDatabase[_infoRarity][_count].itemName = _itemName
		FarmSesh_ItemDatabase[_infoRarity][_count].itemLink = _itemLink
		FarmSesh_ItemDatabase[_infoRarity][_count].totalLooted = _itemCount
		FarmSesh_ItemDatabase[_infoRarity][_count].sellPrice = _infoSellPrice
		FarmSesh_ItemDatabase[_infoRarity].listLength = _count + 1
	end
	
	--Rerender the farmsession frame
	UpdateFrame()
	
	    
end


local function MoneyLooted(message)
	--if (string.match(message, "You ")==nil) then
	--	return
	--end
	local _goldString = string.match(message, "%d+ Gold")
	local _silverString = string.match(message, "%d+ Silver")
	local _copperString = string.match(message, "%d+ Copper")
	local _gold=0
	local _silver=0
	local _copper=0
	
	--If looted ammount contains gold silver or copper add it to money
	if (_goldString) then 
		_gold = tonumber(string.match(_goldString, "%d+"))
	end
	
	if (_silverString) then 
		_silver = tonumber(string.match(_silverString, "%d+"))
	end
	
	if (_copperString) then 
		_copper = tonumber(string.match(_copperString, "%d+"))
	end
	
	local _money = _copper+(_silver*100)+(_gold*10000)
	
	FarmSesh_MoneyAcquired = FarmSesh_MoneyAcquired + _money
	UpdateFrame()
end

--local flags to ensure saved vars are loaded and wealth data is available before initializing
local addonLoaded=false
local playerEnteringWorld=false

--If first time using this addon display the frame and start a new session
local function UpdateSavedVariables()
	if(FarmSesh_ItemDatabase ==nil or FarmSesh_Enabled == nil or FarmSesh_MoneyAcquired == nil) then
		print("Initializing FarmSesh use /fs to toggle the window")
		FarmSesh_Enabled = true
		FarmSeshClearTable()
	end
	if(FarmSesh_RunningTicker==nil) then
		FarmSesh_RunningTicker = 0
	end
	if(FarmSesh_Timer_Enabled==nil) then
		FarmSesh_Timer_Enabled = true
	end
	if (FarmSesh_Timer_Enabled) then
			FarmSesh_Timer:Show()
		else
			FarmSesh_Timer:Hide()
	end
	if (FarmSesh_InterfaceSettings == nil) then
		FarmSesh_InterfaceSettings = {}
		FarmSesh_InterfaceSettings.frameBorderColor = {r=0.0,g=1.0,b=0.0,a=1.0}
		FarmSesh_InterfaceSettings.frameBorderColorText = "Green"
	end
	FarmSesh_InterfacePanel_OnLoad(FarmSesh_InterfacePanel);
	UpdateFrame()
end


--typical event handler
local function eventHandler(self, event, ...)
	if(event == "CHAT_MSG_LOOT" and not(MailFrame:IsVisible())) then
		local message, arg2 = ...
		ItemReceived(message, arg2)
	elseif(event == "CHAT_MSG_MONEY") then
		local message = ...
		MoneyLooted(message)
	elseif(event == "PLAYER_LOGOUT") then
		FarmSesh_RunningTicker = FarmSesh_TickerStore
	elseif(event == "PLAYER_ENTERING_WORLD") then
		playerEnteringWorld = true
		if(addonLoaded) then
			UpdateSavedVariables()
		end
	elseif(event == "ADDON_LOADED") then
		local addonName = ...
		if(addonName == "FarmSesh")then
			addonLoaded = true
			if(playerEnteringWorld) then
				UpdateSavedVariables()
			end
		end
	end
--	if(event == "PLAYER_MONEY" and addonLoaded and playerEnteringWorld) then
--		UpdateFrame()
--	end
	--make sure player entering world and addon loaded before attempting to use saved variables
	
end


--Identify the event handler
FarmSesh_Frame:SetScript("OnEvent", eventHandler)


--Handle Item link clicks
FarmSesh_FrameScrollText:SetScript("OnHyperlinkClick", function(self, link, text, button)
	ChatFrame_OnHyperlinkShow(FarmSesh_Frame, link, text, button)
   end)

-- Handle Clear Data Clicks
FarmSesh_FrameButton:SetScript("OnClick", function(self)
    FarmSeshClearTable()
  end)